Wormholes ---Bellman-Ford算法 最短路径 负权值回路判断 (POJ3259)

Wormholes

Time Limit: 2000MS Memory Limit: 65536K
Total Submissions: 64151 Accepted: 23944

Description

While exploring his many farms, Farmer John has discovered a number of amazing wormholes. A wormhole is very peculiar because it is a one-way path that delivers you to its destination at a time that is BEFORE you entered the wormhole! Each of FJ’s farms comprises N (1 ≤ N ≤ 500) fields conveniently numbered 1..NM (1 ≤ M ≤ 2500) paths, and W (1 ≤ W ≤ 200) wormholes.

As FJ is an avid time-traveling fan, he wants to do the following: start at some field, travel through some paths and wormholes, and return to the starting field a time before his initial departure. Perhaps he will be able to meet himself :) .

To help FJ find out whether this is possible or not, he will supply you with complete maps to F (1 ≤ F ≤ 5) of his farms. No paths will take longer than 10,000 seconds to travel and no wormhole can bring FJ back in time by more than 10,000 seconds.

Input

Line 1: A single integer, FF farm descriptions follow. 
Line 1 of each farm: Three space-separated integers respectively: NM, and W 
Lines 2..M+1 of each farm: Three space-separated numbers (SET) that describe, respectively: a bidirectional path between S and E that requires T seconds to traverse. Two fields might be connected by more than one path. 
Lines M+2..M+W+1 of each farm: Three space-separated numbers (SET) that describe, respectively: A one way path from S to E that also moves the traveler back T seconds.

Output

Lines 1..F: For each farm, output “YES” if FJ can achieve his goal, otherwise output “NO” (do not include the quotes).

Sample Input

2
3 3 1
1 2 2
1 3 4
2 3 1
3 1 3
3 2 1
1 2 3
2 3 4
3 1 8

Sample Output

NO
YES

Hint

For farm 1, FJ cannot travel back in time. 
For farm 2, FJ could travel back in time by the cycle 1->2->3->1, arriving back at his starting location 1 second before he leaves. He could start from anywhere on the cycle to accomplish this.

Source

USACO 2006 December Gold

 

 1.如果存在从源点可达的负权值回路,则最短路径不存在,因为可以重复走这个回路,使得路径长度无穷小。
 2.思路:

    在求出distn-1[ ]之后,再对每条边<u,k>判断一下:加入这条边是否会使得顶点k的最短路径值再缩短,即判断: dist[u]+w(u,k)<dist[k] 是否成立,如果成立,则说明存在从源点可达的负权值回路。 

#include<algorithm>
#include<iostream>
#include<cstdio>
#include<vector>
using namespace std;
#define inf 0x3f3f3f3f
struct edges
{
	int s;
	int e;
	int t;
	edges(int ss,int ee,int tt):s(ss),e(ee),t(tt){}
	edges(){}
};
vector<edges>ed;
int dis[1006];
int f;
int n,m,w;
int Bellman_ford(int v)
{
	for(int i=1;i<=n;i++)
	   dis[i]=inf;
	dis[v]=0;
	for(int k=1;k<n;k++)
	{
		for(int i=0;i<ed.size();i++)
		{
			int s=ed[i].s;
			int e=ed[i].e;
			if(dis[e]>dis[s]+ed[i].t)
			   dis[e]=dis[s]+ed[i].t;
		}
	}
	for(int i=0;i<ed.size();i++)
		{
			int s=ed[i].s;
			int e=ed[i].e;
			if(dis[e]>dis[s]+ed[i].t)
			     return 1;
		}
		return 0;
}
int main()
{
	cin>>f;
	while(f--)
	{
		ed.clear();
		cin>>n>>m>>w;
		for(int i=0;i<m;i++)
		{
			int s,e,t;
			cin>>s>>e>>t;
			ed.push_back(edges(s,e,t));
			ed.push_back(edges(e,s,t));
		}
		for(int i=0;i<w;i++)
		{
			int s,e,t;
			cin>>s>>e>>t;
			ed.push_back(edges(s,e,-t));
		}
		if(Bellman_ford(1))
		   cout<<"YES"<<endl;
		else
		  cout<<"NO"<<endl;
	}
	return 0;
}

 

    原文作者:Bellman - ford算法
    原文地址: https://blog.csdn.net/SSYITwin/article/details/82145546
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞